Trash (Apache Hadoop Common 3.5.0 API)
Description: declaration: package: org.apache.hadoop.fs, class: Trash

Package org.apache.hadoop.fs

# Class Trash

java.lang.Object
org.apache.hadoop.conf.Configured
org.apache.hadoop.fs.Trash

All Implemented Interfaces:
  `Configurable`

@Public @Stable public class Trash extends Configured
Provides a trash facility which supports pluggable Trash policies. See the implementation of the configured TrashPolicy for more details.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Trash(Configuration conf)`
  Construct a trash can accessor.
  `Trash(FileSystem fs, Configuration conf)`
  Construct a trash can accessor for the FileSystem provided.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `checkpoint()`
  Create a trash checkpoint.
  `void`
  `expunge()`
  Delete old checkpoint(s).
  `void`
  `expungeImmediately()`
  Delete all trash immediately.
  `Path`
  `getCurrentTrashDir(Path path)`
  `Runnable`
  `getEmptier()`
  Return a `Runnable` that periodically empties the trash of all users, intended to be run by the superuser.
  `boolean`
  `isEnabled()`
  Returns whether the trash is enabled for this filesystem.
  `static boolean`
  `moveToAppropriateTrash(FileSystem fs, Path p, Configuration conf)`
  In case of the symlinks or mount points, one has to move the appropriate trashbin in the actual volume of the path p being deleted.
  `boolean`
  `moveToTrash(Path path)`
  Move a file or directory to the current trash directory.

  ### Methods inherited from class org.apache.hadoop.conf.Configured

  `getConf, setConf`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Trash

    public Trash(Configuration conf) throws IOException
    Construct a trash can accessor.
    Parameters:
      `conf` - a Configuration
    Throws:
      `IOException` - raised on errors performing I/O.

  - ### Trash

    public Trash(FileSystem fs, Configuration conf) throws IOException
    Construct a trash can accessor for the FileSystem provided.
    Parameters:
      `fs` - the FileSystem
      `conf` - a Configuration
    Throws:
      `IOException` - raised on errors performing I/O.

- ## Method Details

  - ### moveToAppropriateTrash

    public static boolean moveToAppropriateTrash(FileSystem fs, Path p, Configuration conf) throws IOException
    In case of the symlinks or mount points, one has to move the appropriate trashbin in the actual volume of the path p being deleted. Hence we get the file system of the fully-qualified resolved-path and then move the path p to the trashbin in that volume,
    Parameters:
      `fs` - - the filesystem of path p
      `p` - - the path being deleted - to be moved to trash
      `conf` - - configuration
    Returns:
      false if the item is already in the trash or trash is disabled
    Throws:
      `IOException` - on error

  - ### isEnabled

    public boolean isEnabled()
    Returns whether the trash is enabled for this filesystem.
    Returns:
      return if isEnabled true,not false.

  - ### moveToTrash

    public boolean moveToTrash(Path path) throws IOException
    Move a file or directory to the current trash directory.
    Parameters:
      `path` - the path.
    Returns:
      false if the item is already in the trash or trash is disabled
    Throws:
      `IOException` - raised on errors performing I/O.

  - ### checkpoint

    public void checkpoint() throws IOException
    Create a trash checkpoint.
    Throws:
      `IOException` - raised on errors performing I/O.

  - ### expunge

    public void expunge() throws IOException
    Delete old checkpoint(s).
    Throws:
      `IOException` - raised on errors performing I/O.

  - ### expungeImmediately

    public void expungeImmediately() throws IOException
    Delete all trash immediately.
    Throws:
      `IOException` - raised on errors performing I/O.

  - ### getEmptier

    public Runnable getEmptier() throws IOException
    Return a `Runnable` that periodically empties the trash of all users, intended to be run by the superuser.
    Returns:
      Runnable.
    Throws:
      `IOException` - on raised on errors performing I/O.

  - ### getCurrentTrashDir

    public Path getCurrentTrashDir(Path path) throws IOException
    Throws:
      `IOException`